Attribute VB_Name = "Module1"
' Direct3D Sample 1 / Exemple Direct3D7 1


Public DirectX As DirectX7
Public DD As DirectDraw7
Public D3D As Direct3D7
Public EnumDevice As Direct3DEnumDevices
Public EnumDD As DirectDrawEnum
Public Primary As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Public D3DSurface As DirectDrawSurface7
Public Device As Direct3DDevice7
Public Viewport As D3DVIEWPORT7
Public ZBuffer As DirectDrawSurface7

Public DeviceReturn As Long
Public DriverGUID As String
Public AppStop As Boolean
Public Triangle1(2) As D3DVERTEX
Public Triangle2(2) As D3DVERTEX

Public Texture(50) As DirectDrawSurface7

Public Enum TEXTUREFLAGS
 D3DTEXTR_DEFAULT = 0
 D3DTEXTR_TRANSPARENTBLACK = 1
 D3DTEXTR_TRANSPARENTWHITE = 2
End Enum

Public Function CreateTextureSurface(sFile As String, extraFlags As TEXTUREFLAGS, w As Long, h As Long) As DirectDrawSurface7
 Debug.Print "Debut Crate"
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
                        
            
            If ((D3DTEXTR_TRANSPARENTBLACK And extraFlags) _
                  Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags)) Then
                  If (.lRGBAlphaBitMask = 0) Then bOK = False
                  'DDPF_ALPHAPIXELS
            Else
                  If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
                  
            
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If
    Debug.Print "Requis"
    If (((D3DTEXTR_TRANSPARENTBLACK And extraFlags) _
          Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT
        
    Else
        ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB
  
    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddscaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddscaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0
 Debug.Print "Ohoh"
    Else
            ddsd3.ddscaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddscaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

 
    End If

    If sFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        Set SurfaceObject = DD.CreateSurfaceFromFile(sFile, ddsd3)
    End If
    
    
    Set CreateTextureSurface = SurfaceObject
    
    If Not (((D3DTEXTR_TRANSPARENTBLACK = extraFlags) _
        Or (D3DTEXTR_TRANSPARENTWHITE = extraFlags)) _
        ) Then Exit Function

        
        
    Dim ddsd4 As DDSURFACEDESC2
    Dim mem() As Integer
    Dim lAlphaMask As Long
    Dim lRGBMask As Long
    Dim lColorKey As Long
    Dim c As Long
    Dim x As Long
    Dim y As Long
    Dim r1 As RECT
    
    ReDim mem(ddsd.lHeight * ddsd.lPitch)
                        
    With ddsd.ddpfPixelFormat
        lAlphaMask = .lRGBAlphaBitMask
        lRGBMask = .lRBitMask Or .lGBitMask Or .lBBitMask
    End With
    If (extraFlags And D3DTEXTR_TRANSPARENTWHITE) Then
        lColorKey = lRGBMask     'color key on white
    End If
    If (extraFlags And D3DTEXTR_TRANSPARENTBLACK) Then
        lColorKey = 0                  'color key on black
    End If
    
    'pixel format should be 16 bit because thats what we selected
    Dim rl As RECT
    
    r1.Bottom = ddsd.lHeight
    r1.Right = ddsd.lWidth
    SurfaceObject.Lock r1, ddsd3, DDLOCK_WAIT, 0
    
    ' Add an opaque alpha value to each non-colorkeyed pixel
    For y = 0 To ddsd4.lHeight - 1
        For x = 0 To ddsd4.lWidth - 1
            c = SurfaceObject.GetLockedPixel(x, y)
            If c And lRGBMask <> lColorKey Then
                SurfaceObject.SetLockedPixel x, y, c Or lAlphaMask
            End If
        Next
    Next

    SurfaceObject.Unlock r1
        
End Function


Function DDRect(x, y, x1, y1) As RECT
With DDRect
  .Left = x
  .Right = x1
  .Top = y
  .Bottom = y1
  End With
End Function

Public Sub SetViewFrustrum(nearZ As Single, farZ As Single, radian As Single)
    Dim x As Single
    Dim y As Single
            
    Dim matProj As D3DMATRIX
    Dim ddsd As DDSURFACEDESC2
     BackBuffer.GetSurfaceDesc ddsd
    
    x = ddsd.lHeight / ddsd.lWidth
    radian = radian / 2
    
    matProj.rc11 = Cos(radian) / Sin(radian)
    radian = radian * x
    matProj.rc22 = Cos(radian) / Sin(radian)
    matProj.rc33 = farZ / (farZ - nearZ)
    matProj.rc43 = -matProj.rc33 * nearZ
    matProj.rc34 = 1
    If Device Is Nothing Then Exit Sub
    Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    
End Sub


Sub AppError(Text As String)
 Unload3D
 AppStop = True
 MsgBox Text + Chr(13) + Chr(13) + Err.Description + Chr(13) + Chr(10) + "Contactez Sylvain Dupont sur sylvain.dupont@francimel.com" + Chr(13) + "Contact Sylvain Dupont at sylvain.dupont@francimel.com", vbCritical, "Erreur / Error"
 End
 
End Sub

'---------------------
' Direct3D 7 Sample 2
'---------------------
Function AttatchZBuffer() As Boolean
    On Local Error GoTo errOut
            
    
    Dim hr As Integer
    Dim ddsZBuff  As DirectDrawSurface7
    Dim ddsd As DDSURFACEDESC2
    Dim ddsdZ As DDSURFACEDESC2
    
    Dim l As Long
    Dim i As Long

 
    Dim fenum As Direct3DEnumPixelFormats
    Set fenum = D3D.GetEnumZBufferFormats(DriverGUID)
    l = fenum.GetCount()
    
    If l = 0 Then
       
        Debug.Print "Aucun ZBuffer"
        AttatchZBuffer = True
       Exit Function
    End If
    
    For i = 1 To l
        Call fenum.GetItem(i, ddsdZ.ddpfPixelFormat)
    
    Debug.Print "Z buffer"; ddsdZ.ddpfPixelFormat.lZBufferBitDepth
    If ddsdZ.ddpfPixelFormat.lZBufferBitDepth = 16 Then Exit For
    
    Next
    

                           
    ddsdZ.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    ddsdZ.ddscaps.lCaps = DDSCAPS_ZBUFFER Or DDSCAPS_VIDEOMEMORY
    ddsdZ.lWidth = 640
    ddsdZ.lHeight = 480
    
    Set ZBuffer = DD.CreateSurface(ddsdZ)
    
    BackBuffer.AddAttachedSurface ZBuffer
    
    AttatchZBuffer = True
    Exit Function
errOut:
    Debug.Print Err.Description + " PRob"
    AttatchZBuffer = False
End Function

Public Function DXColor(r As Single, g As Single, b As Single, a As Single) As D3DCOLORVALUE
 With DXColor
  .a = a
  .b = b
  .g = g
  .r = r
 End With
 
End Function

Sub Main()
 On Error GoTo errs
 '
 ' Procdure d'initialisation
 ' Init procedure
 Set DirectX = New DirectX7

 
 Set DD = DirectX.DirectDrawCreate("")
 Set D3D = DD.GetDirect3D
 
 
 ' Et voici la dtection de matriel !!
 ' And this is the hardware detection !
 Set EnumDD = DirectX.GetDDEnum
 Set EnumDevice = D3D.GetDevicesEnum
 
 ' Demande  l'utilisateur quel driver il veut(si plus de 2)
 ' Ask user the driver to use.
 If EnumDevice.GetCount > 1 Then
  DriverSelect.List1.Clear
  For i = 1 To EnumDevice.GetCount
   DriverSelect.List1.AddItem EnumDevice.GetDescription(i)
  Next i
  DriverSelect.Show 1
  If DeviceReturn = -1 Then Unload3D: End
  DriverGUID = EnumDevice.GetGuid(DeviceReturn)
 End If

 'On ferme tout et on recommence
' Close all.
 Set DD = Nothing
 
 Form1.Show
 
 Set DD = DirectX.DirectDrawCreate(EnumDD.GetGuid(1))
 Set D3D = DD.GetDirect3D
 DD.SetCooperativeLevel Form1.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWREBOOT
 DD.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT
 
 
 ' Cre la surface primaire / Create the primary surface
 Dim ddsd2 As DDSURFACEDESC2
 ddsd2.lFlags = DDSD_BACKBUFFERCOUNT Or DDSD_CAPS
 ddsd2.ddscaps.lCaps = DDSCAPS_COMPLEX Or DDSCAPS_FLIP Or DDSCAPS_PRIMARYSURFACE Or DDSCAPS_VIDEOMEMORY Or DDSCAPS_3DDEVICE
 ddsd2.lBackBufferCount = 1
 Set Primary = DD.CreateSurface(ddsd2)
 
 'Cre le BackBuffer / Create the backbuffer
 Dim ddscaps As DDSCAPS2
 ddscaps.lCaps = DDSCAPS_BACKBUFFER
 Set BackBuffer = Primary.GetAttachedSurface(ddscaps)
 
BackBuffer.BltColorFill DDRect(0, 0, 640, 480), 0

 
' Le Z-Buffer est pour le tutorial 2 / the z-buffer is for the tutorial 2
 'If AttatchZBuffer() = False Then AppError "Le Z Buffer n'a pas pas pu tre cr. / The Z-Buffer haven't been created"
Set Device = D3D.CreateDevice(DriverGUID, BackBuffer)
 
 
 ' Dfinit le viewport / Set the viewport
 Viewport.lX = 0
 Viewport.lY = 0
 Viewport.lHeight = 480
 Viewport.lWidth = 640
 Viewport.minz = 0#
 Viewport.maxz = 1#
 Device.SetViewport Viewport
 
 
 SetDefaults
 DrawScene
 AppLoop
errs:
 Unload3D
 End
End Sub
Private Sub DrawScene()
  Triangle1(0) = Vertex(-5, -5, 0, 0, 0, -1, 0, 1)
  Triangle1(1) = Vertex(0, 5, 0, 0, 0, -1, 1, 1)
  Triangle1(2) = Vertex(5, -5, 0, 0, 0, -1, 1, 0)
  
  Triangle2(0) = Vertex(5, -5, 0, 0, 0, 1, 1, 0)
  Triangle2(1) = Vertex(0, 5, 0, 0, 0, 1, 1, 1)
  Triangle2(2) = Vertex(-5, -5, 0, 0, 0, 1, 0, 1)
End Sub

Function RECT(x, y, x1, y1) As D3DRECT
 With RECT
  .x1 = x
  .X2 = x1
  .y1 = y
  .Y2 = y1
  End With
End Function

Public Sub AppLoop()
Dim matrix As D3DMATRIX
Dim mat2 As D3DMATRIX
Dim identity As D3DMATRIX
 On Error GoTo ert
  Device.SetRenderTarget BackBuffer
 
 'Device.SetRenderState D3DRENDERSTATE_ZENABLE, 1
 'Device.SetRenderState D3DRENDERSTATE_ZWRITEENABLE, True
 

Set Texture(1) = CreateTextureSurface(App.Path + "\nuages2.bmp", D3DTEXTR_DEFAULT, 0, 0)
Dim ClearTab(1) As D3DRECT
 ClearTab(0) = RECT(0, 0, 640, 480)
 DirectX.IdentityMatrix matrix
 DirectX.IdentityMatrix mat2
 ang = 3
 Do
  
   Device.Clear 1, ClearTab, D3DCLEAR_TARGET, 0, 1, 0
   
   Device.BeginScene
   Device.SetTexture 0, Texture(1)
   
   DirectX.RotateXMatrix mat2, ang * 3.1415 / 180
   DirectX.MatrixMultiply matrix, matrix, mat2
   DirectX.RotateZMatrix mat2, ang * 3.1415 / 180
   DirectX.MatrixMultiply matrix, matrix, mat2
   
   Device.SetTransform D3DTRANSFORMSTATE_WORLD, matrix
   Device.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Triangle2(0), 3, D3DDP_WAIT
   Device.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Triangle1(0), 3, D3DDP_WAIT
   Device.EndScene
 
   BackBuffer.SetFontTransparency True
   BackBuffer.SetForeColor RGB(256, 128, 0)
   BackBuffer.DrawText 180, 400, "Direct3D7 Sample 1 - Display a spin triangle", False
   Primary.Flip Nothing, DDFLIP_WAIT
   If Err.Number = DDERR_SURFACELOST Then Primary.restore
   DoEvents
 Loop Until AppStop = True
 End
ert:
 Debug.Print Err.Description + " " + CStr(Err.Number) + "OK"
 Resume Next
 
End Sub





Public Sub SetDefaults()
  Dim matWorld As D3DMATRIX, matView As D3DMATRIX
    Dim Mat As D3DMATERIAL7
    Dim light As D3DLIGHT7
    
    DirectX.IdentityMatrix matWorld
    DirectX.IdentityMatrix matView
    Call DirectX.ViewMatrix(matView, Vector(0, 0, -20), Vector(0, 0, 0), Vector(0, 1, 0), 0)
    
    Device.SetTransform D3DTRANSFORMSTATE_WORLD, matWorld
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, matView
    SetViewFrustrum 1, 1000, 3.1416 / 4
     
    With light
        .dltType = D3DLIGHT_POINT
 
        .ambient = DXColor(1, 1, 0.5, 0.5)
        .diffuse = DXColor(1, 1, 0.5, 0.5)
        .specular = DXColor(1, 1, 0.5, 0.5)
        .position.y = 10
    End With
        
    Device.SetLight 0, light
    Device.LightEnable 0, True
    
    Mat.ambient = DXColor(4, 4, 4, 0)
    Mat.diffuse = DXColor(0.5, 0.5, 0.5, 1)
    Mat.specular = DXColor(0.5, 0.5, 0.5, 0)
    Mat.emissive = DXColor(0.5, 0.5, 0.5, 0)
    
    ' Set the material as the current material
  Device.SetMaterial Mat
    
    
End Sub
Public Function Material(ambient As D3DCOLORVALUE, diffuse As D3DCOLORVALUE, emissive As D3DCOLORVALUE, specular As D3DCOLORVALUE, power As Single, TexHandle As Integer) As D3DMATERIAL7
 With Material
  .ambient = ambient
  .diffuse = diffuse
  .emissive = emissive
  .power = power
  .specular = specular
 End With
End Function
Sub Touche()
 If gauche = True Then ang = ang - 0.05
 If droite = True Then ang = ang + 0.05
 If haut = True Then xpos = xpos + Cos(ang) * 0.5: zpos = zpos + Sin(ang) + 0.5
End Sub

Sub Unload3D()
 '------------------------------------------------------------
 ' Je crois que l'on n'est mme plus oblig de passer par l !
 '------------------------------------------------------------
 
 '* I think these code is inutile
AppStop = True
 DD.RestoreDisplayMode
 DD.SetCooperativeLevel Form1.hWnd, DDSCL_NORMAL
 Set Primary = Nothing
 Set BackBuffer = Nothing
 Set Device = Nothing
 Set DD = Nothing
 Set D3D = Nothing
 Set DirectX = Nothing

End Sub


Public Function Vertex(x As Single, y As Single, z As Single, nx As Single, ny As Single, nz As Single, tv As Single, tu As Single) As D3DVERTEX
With Vertex
 .nx = nx
 .ny = ny
 .nz = nz
 .tu = tu
 .tv = tv
 .x = x
 .y = y
 .z = z
End With
End Function

Function Vector(x As Single, y As Single, z As Single) As D3DVECTOR
 With Vector
  .x = x
  .y = y
  .z = z
 End With
End Function

